<?php
/**
* Flexi Trendy News - Joomla Module
* Version			: 2.0
* Created by		: Techicore.Com for RumahBelanja.com
* Created on		: v1.0 - November 2010
* Updated			: v2.0 - 24 December 2011
* Package			: Joomla 1.6.x
* Based on			: Flexi Latest News
* License			: http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/

// no direct access
defined('_JEXEC') or die;

require_once JPATH_SITE.'/components/com_content/helpers/route.php';

jimport('joomla.application.component.model');

JModel::addIncludePath(JPATH_SITE.'/components/com_content/models', 'ContentModel');

abstract class modFlexiTrendyNewsHelper
{
	public static function getList(&$params)
	{
		// Get the dbo
		$db = JFactory::getDbo();
		$user= JFactory::getUser();

		// Get an instance of the generic articles model
		$model = JModel::getInstance('Articles', 'ContentModel', array('ignore_request' => true));

		//Get the config
		$config =& JFactory::getConfig();
		$tzoffset = $config->getValue('config.offset');
		
		// Set application parameters in model
		$app = JFactory::getApplication();
		$appParams = $app->getParams();
		$model->setState('params', $appParams);
		
		// Get Global Parameters
		$sef 			= $app->getCfg('sef');
		$sef_rewrite 	= $app->getCfg('sef_rewrite');
		$sef_suffix 	= $app->getCfg('sef_suffix');
		
		// Set the filters based on the module params
		$model->setState('list.start', 0);
		$model->setState('list.limit', (int) $params->get('$countnum', 5));
		$model->setState('filter.published', 1);
		
		// Access filter
		$access = !JComponentHelper::getParams('com_content')->get('show_noauth');
		$authorised = JAccess::getAuthorisedViewLevels(JFactory::getUser()->get('id'));
		$model->setState('filter.access', $access);
		
		// Category filter
		$model->setState('filter.category_id', $params->get('catid', array()));

		// User filter
		$userId = JFactory::getUser()->get('id');
		switch ($params->get('user_id'))
		{
			case 'by_me':
				$model->setState('filter.author_id', (int) $userId);
				break;
			case 'not_me':
				$model->setState('filter.author_id', $userId);
				$model->setState('filter.author_id.include', false);
				break;

			case '0':
				break;

			default:
				$model->setState('filter.author_id', (int) $params->get('user_id'));
				break;
		}
		
		// Filter by language
		$model->setState('filter.language',$app->getLanguageFilter());
		
		//  Featured switch
		switch ($params->get('show_featured'))
		{
			case '1':
				$model->setState('filter.featured', 'only');
				break;
			case '0':
				$model->setState('filter.featured', 'hide');
				break;
			default:
				$model->setState('filter.featured', 'show');
				break;
		}

		//Get Module Parameters
		$order_dir			= $params->get( 'ordering');
		$limittitle 		= intval( $params->get( 'limittitle', 15 ) );
		$combination_type	= $params->get( 'combination_type', 1 );
		$time_sys			= $params->get( 'time_sys');
		$name_type 			= $params->get( 'name_type', 1);
		$date_type			= $params->get( 'date_type', 0);
		
		$permitedtags =  "<i><b><strong><br><a>";
		
		//SEO CALCULATION
		$cbintegration_plusseo = $sef + $sef_rewrite + $combination_type;
		
		// Set ordering
		$order_map = array(
			'0' => 'a.hits',
			'1' => 'a.hits',
		);
		$ordering = JArrayHelper::getValue($order_map, $params->get('ordering'), 'a.publish_up');
		
		switch($order_dir) {
			case 0:
			default:
				$dir = 'DESC';
			break;
			case 1:
				$dir = 'ASC';
			break;	
		}
	
		$model->setState('list.ordering', $ordering);
		$model->setState('list.direction', $dir);
		
		$items = $model->getItems();
		
		foreach ($items as &$item) {
			$item->slug = $item->id.':'.$item->alias;
			$item->catslug = $item->catid.':'.$item->category_alias;

			if ($access || in_array($item->access, $authorised)) {
				// We know that user has the privilege to view the article
				$item->link = JRoute::_(ContentHelperRoute::getArticleRoute($item->slug, $item->catslug));
			} else {
				$item->link = JRoute::_('index.php?option=com_users&view=login');
			}
			
			$item->text = htmlspecialchars( $item->title );
			if($limittitle > 0) { //if the limit of title character more than 0
					$item->text = featnews_limittext($item->text,$permitedtags,$limittitle);
				}
			$item->hits = htmlspecialchars( $item->hits );
			$item->created_by_alias = htmlspecialchars( $item->created_by_alias );
			$item->created_by = htmlspecialchars( $item->created_by );
			$item->name = htmlspecialchars( $item->author );
			
			//Created or Modified or Publish Up 
			switch ( $date_type ) {
			case 0;
			default;
				$item->created= htmlspecialchars( $item->created);
			break;
			
			case 1;
				$item->created= htmlspecialchars( $item->modified);
			break;
			
			case 2;
				$item->created= htmlspecialchars( $item->publish_up);
			break;
			}
		}

		return $items;
	}
}

//added Special Function
if (!function_exists("featnews_limittext")) {
function featnews_limittext($text,$permitedtags,$limittitle) {
	$strip = strip_tags($text);
	$endText = (strlen($strip) > $limittitle) ? "..." : ""; 
	$strip = substr($strip, 0, $limittitle);
	$striptag = strip_tags($text, $permitedtags);
	$lentag = strlen($striptag);
	
	$display = "";
	
	$x = 0;
	$ignore = true;
	for($n = 0; $n < $limittitle; $n++) {
		for($m = $x; $m < $lentag; $m++) {
			$x++;
			if($striptag[$m] == "<") {
				$ignore = false;
			} else if($striptag[$m] == ">") {
				$ignore = true;
			}
			if($ignore == true) {
				if($strip[$n] != $striptag[$m]) {
					$display .= $striptag[$m];
				} else {
					$display .= $strip[$n];
					break;
				}
			} else {
				$display .= $striptag[$m];
			}
		}
	}
	return fix_tags ('<span>'.$display.$endText.'</span>');}
}


//function taken from https://svn.typo3.org/TYPO3v4/Extensions/pdf_generator2/trunk/html2ps/xhtml.utils.inc.php
if(!function_exists('fix_tags')) {
function fix_tags($html) {
  $result = "";
  $tag_stack = array();

  // these corrections can simplify the regexp used to parse tags
  // remove whitespaces before '/' and between '/' and '>' in autoclosing tags
  $html = preg_replace("#\s*/\s*>#is","/>",$html);
  // remove whitespaces between '<', '/' and first tag letter in closing tags
  $html = preg_replace("#<\s*/\s*#is","</",$html);
  // remove whitespaces between '<' and first tag letter 
  $html = preg_replace("#<\s+#is","<",$html);

  while (preg_match("#(.*?)(<([a-z\d]+)[^>]*/>|<([a-z\d]+)[^>]*(?<!/)>|</([a-z\d]+)[^>]*>)#is",$html,$matches)) {
    $result .= $matches[1];
    $html = substr($html, strlen($matches[0]));

    // Closing tag 
    if (isset($matches[5])) { 
      $tag = $matches[5];

      if ($tag == $tag_stack[0]) {
        // Matched the last opening tag (normal state) 
        // Just pop opening tag from the stack
        array_shift($tag_stack);
        $result .= $matches[2];
      } elseif (array_search($tag, $tag_stack)) { 
        // We'll never should close 'table' tag such way, so let's check if any 'tables' found on the stack
        $no_critical_tags = !array_search('table',$tag_stack);
        if (!$no_critical_tags) {
          $no_critical_tags = (array_search('table',$tag_stack) >= array_search($tag, $tag_stack));
        };

        if ($no_critical_tags) {
          // Corresponding opening tag exist on the stack (somewhere deep)
          // Note that we can forget about 0 value returned by array_search, becaus it is handled by previous 'if'
          
          // Insert a set of closing tags for all non-matching tags
          $i = 0;
          while ($tag_stack[$i] != $tag) {
            $result .= "</{$tag_stack[$i]}> ";
            $i++;
          }; 
          
          // close current tag
          $result .= "</{$tag_stack[$i]}> ";
          // remove it from the stack
          array_splice($tag_stack, $i, 1);
          // if this tag is not "critical", reopen "run-off" tags
          $no_reopen_tags = array("tr","td","table","marquee","body","html");
          if (array_search($tag, $no_reopen_tags) === false) {
            while ($i > 0) {
              $i--;
              $result .= "<{$tag_stack[$i]}> ";
            }; 
          } else {
            array_splice($tag_stack, 0, $i);
          };
        };
      } else {
        // No such tag found on the stack, just remove it (do nothing in out case, as we have to explicitly 
        // add things to result
      };
    } elseif (isset($matches[4])) {
      // Opening tag
      $tag = $matches[4];
      array_unshift($tag_stack, $tag);
      $result .= $matches[2];
    } else {
      // Autoclosing tag; do nothing specific
      $result .= $matches[2];
    };
  };

  // Close all tags left
  while (count($tag_stack) > 0) {
    $tag = array_shift($tag_stack);
    $result .= "</".$tag.">";
  }	

  return $result;
}
}